<template>

  <Head>
    <title>Roles - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow border-top-purple">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-shield-alt me-2"></i> ROLES</span>
              </div>
              <div class="card-body">
                <div class="row">
                  <div class="col-md-6 mb-2 mb-md-0">
                    <!-- link view create role -->
                    <Link href="/apps/roles/create" v-if="hasAnyPermission(['roles.create'])"
                      class="btn btn-primary input-group-text"> <i class="fa fa-plus-circle me-2"></i> Create Role
                    </Link>

                  </div>
                  <!-- form search -->
                  <div class="col-md-6">
                    <form @submit.prevent="handleSearch">
                      <div class="input-group mb-3">
                        <input type="text" class="form-control" v-model="search" placeholder="Search Role...">
                        <button class="btn btn-primary input-group-text" type="submit"> <i
                            class="fa fa-search me-2"></i></button>
                      </div>
                    </form>
                  </div>
                </div>

                <!-- roles table -->
                <div class="table-responsive">
                  <table class="table table-hover">
                    <thead class="bg-primary">
                      <tr>
                        <th scope="col" class="text-center">#</th>
                        <th scope="col">Role Name</th>
                        <th scope="col" style="width:50%">Permissions</th>
                        <th scope="col" style="width:20%" class="text-center">Actions</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(role, index) in roles.data" :key="index">
                        <td class="fw-bold text-center">
                          {{ ++index + (roles.current_page - 1) *
                          roles.per_page }}
                        </td>
                        <td>
                          {{ role.name }}
                        </td>
                        <td>
                          <span v-for="(permission, index) in role.permissions" :key="index"
                            class="badge badge-primary shadow border-0 ms-2 mb-2">
                            {{ permission.name }}
                          </span>
                        </td>
                        <td class="text-center">
                          <!-- link view edit -->
                          <Link :href="`/apps/roles/${role.id}/edit`" v-if="hasAnyPermission(['roles.edit'])"
                            class="btn btn-info btn-sm mb-md-0 mx-1 mb-2 mb-sm-0"><i
                            class="fa fa-pencil-alt text-white fa-fw"></i>
                          </Link>
                          <!-- button delete -->
                          <button @click.prevent="destroy(role.id)" v-if="hasAnyPermission(['roles.delete'])"
                            class="btn btn-danger btn-sm mx-1"><i class="fa fa-trash fa-fw"></i>
                          </button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
                <!-- pagination -->
                <Pagination :links="roles.links" align="end" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue'

// import component pagination
import Pagination from '../../../Components/Pagination.vue'

// import Head and Link from inertia
import { Head, Link } from '@inertiajs/vue3'

// import ref from vue
import { ref } from 'vue';

// import inertia adapter
import { router } from '@inertiajs/vue3'

// import sweet alert2
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,
  components: {
    Head,
    Link,
    Pagination
  },

  // props
  props: {
    roles: Object,
  },

  setup() {
    // define state search
    const search = ref('' || (new URL(document.location)).searchParams.get('q'));
  

    // define method search
    const handleSearch = () => {
      router.get('/apps/roles', {
        // send params 'q' with value from stae 'search'
        q: search.value,
      });
    }

    // deine method destroy
    const destroy = (id) => {
      Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      }).then((result) => {
        if (result.isConfirmed) {
          router.delete(`/apps/roles/${id}`);
          Swal.fire({
            title: 'Deleted!',
            text: 'Role has been deleted.',
            icon: 'success',
            timer: 2000,
            showConfirmButton: false,
          });
        }
      })
    }
    
    // return
    return {
        search,
        destroy,
        handleSearch,
      }
  }
}
</script>